package com.syc.slm.slmbi.controller;

import com.syc.slm.common.core.util.R;
import com.syc.slm.slmbi.dto.InstrumentPanelConfigDTO;
import com.syc.slm.slmbi.service.InstrumentPanelConfigService;
import com.syc.slm.slmbi.vo.InstrumentPanelConfigVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * slm-bi
 * 仪表板样式以及数据配置
 *
 * @author : lin
 * @date : 2021-03-25 19:09
 **/

@RequestMapping("/panel-configs")
@RestController
@Api(value = "仪表板样式以及数据配置")
public class InstrumentPanelConfigController {

    @Autowired
    private InstrumentPanelConfigService instrumentPanelConfigService;

    @PostMapping
    @ApiOperation("保存仪表板样式以及数据配置")
    public R<String> saveInstrumentPanelConfig(@RequestBody InstrumentPanelConfigDTO config) {
        return R.ok(instrumentPanelConfigService.saveConfig(config));
    }

    @PostMapping("/publish")
    @ApiOperation("保存发布仪表板样式以及数据配置")
    public R<String> publish(@RequestBody InstrumentPanelConfigDTO config) {
        return R.ok(instrumentPanelConfigService.publish(config));
    }

    @GetMapping("/{panelId}")
    @ApiOperation("根据仪表板id获取仪表板配置")
    @ApiImplicitParam(name = "panelId", value = "仪表板id")
    public R<InstrumentPanelConfigVo> getConfigByPanelId(
        @PathVariable("panelId") String panelId) {
        return R.ok(instrumentPanelConfigService.getConfigByPanelId(panelId));
    }

}
