package com.syc.slm.slmbi.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.syc.slm.common.core.util.R;
import com.syc.slm.slmbi.dto.HistoryVariableDTO;
import com.syc.slm.slmbi.dto.RealTimeVariableDTO;
import com.syc.slm.slmbi.dto.VariableDTO;
import com.syc.slm.slmbi.service.VariableService;
import com.syc.slm.slmbi.vo.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 * slm-bi
 * 用户信息
 *
 * @author : lin
 * @date : 2021-03-25 18:45
 **/
@RestController
@RequestMapping("/variables")
@Api(description = "变量控件")
public class VariableController {
    @Autowired
    private VariableService variableService;

    @GetMapping
    @ApiOperation("获取变量列表")
    public R<IPage<VariableVo>> getVariableList(@RequestBody VariableDTO variableDTO) {
        return R.ok(variableService.getVariableList(variableDTO));
    }

    @GetMapping("/real-time")
    @ApiOperation("获取变量实时数据")
    public R<Map<String, List<Map<String, RealTimeVariableVo>>>> getVariableRealTimeDataList(
        @RequestBody RealTimeVariableDTO variableDTO) {
        return R.ok(variableService.getVariableRealTimeDataList(variableDTO));
    }

    @GetMapping("/source")
    @ApiOperation("获取变量来源列表")
    public R<List<VariableSourceVo>> getVariableSourceList() {
        return R.ok(variableService.getVariableSourceList());
    }

    @GetMapping("/device")
    @ApiOperation("获取变量所属设备列表")
    public R<List<VariableDeviceVo>> getVariableDeviceList() {
        return R.ok(variableService.getVariableDeviceList());
    }

    @GetMapping("/history")
    @ApiOperation("获取变量历史数据")
    public R<Map<String, List<Map<String, HistoryVariableVo>>>> getVariableHistoryDataList(@RequestBody HistoryVariableDTO variableDTO) {
        return R.ok(variableService.getVariableHistoryDataList(variableDTO));
    }
}
